#!/usr/bin/env python
# coding: utf-8

# In[ ]:


if __name__ == "__main__":
    """ For running the different cluster analysis, uncomment the different sections.
        For example, if I want to run the analysis on the UNIVARIATE_v1, I would uncomment
        line number 11 to 29. """
    #### UNIVARIATE_v1 ####
    #Paths
    path_csv = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Finished_python_code/Data sets/Univariate_v1/'
    path_pictures_euc = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
    path_pictures_dtw = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
    
    # Filenames
    dataset_name = 'Univariate_v1'

    filenames = ['Gearbox_temp_1day_30A_R']
    
    df_names = ['gearboxTemp']
    
    skip_rows = [1]
    alphas = [1]
    file_ending = "_alphas_1"
    lenght_moving_average = 5
    window_size_dtw = 280
    #########################    
    

    
#     #### UNIVARIATE_v2 ####
#     #Paths
#     path_csv = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Finished_python_code/Data sets/Univariate_v2/'
#     path_pictures_euc = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
#     path_pictures_dtw = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
    
#     # Filenames
#     dataset_name = 'Univariate_v2'

#     filenames = ['Gearbox_temp_1day_30A_R_v2']
    
#     df_names = ['gearboxTemp']
    
#     skip_rows = [1]
#     alphas = [1]
#     file_ending = "_alphas_1"
#     lenght_moving_average = 5
#     window_size_dtw = 280   
#     #########################   
    
    
#    #### MULTIVARIATE_V1 #####
#     #Paths
#     path_csv = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Finished_python_code/Data sets/Multivariate_v1/'
#     path_pictures_euc = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
#     path_pictures_dtw = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
    
#     # Filenames
#     dataset_name = 'Multivariate_v1'


#     filenames = ['Gearbox_temp_1day_30A_R_v2', 
#                  'Wind_speed_nascell_v2', 
#                  'Generator_speed_v2', 
#                  'Positional_derivative_v2_unwrapped']
    
#     df_names = ['gearboxTemp', 'windSpd','genSpd','posDeviation']
    
#     skip_rows = [1,1,1,0]
#     alphas = [8,1,1,1]
#     file_ending = "_alphas_8111"
#     lenght_moving_average = 5
#     window_size_dtw = 280   
#     #########################  
    

#     #### MULTIVARIATE_V2 #####
#     # Paths
#     path_csv = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Finished_python_code/Data sets/Multivariate_v2/'
#     path_pictures_euc = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
#     path_pictures_dtw = 'C:/Users/ewaaga/OneDrive - KONGSBERG MARITIME AS/Pictures/'
 
#     # Filenames
#     dataset_name = 'Multivariate_v2'

#     filenames = ['power_mv2',
#                  'gearboxTemp_mv2', 
#                  'generatorSpeed_mv2', 
#                  'windSpeed_mv2', 
#                  'windDir_mv2', 
#                  'outsideTemp_mv2']
    
#     skip_rows = [0,0,0,0,0,0]
#     alphas = [1,1,1,1,0,0]
#     file_ending = "_alphas_111100"
#     lenght_moving_average = 100
    
#     df_names = ['power', 'gearboxTemp','genSpd', 'windSpd', 'windDir', 'extTemp']
#     window_size_dtw = 620 
#     #########################

    
    # Initiate dataframes
    dataframes = Dataframe_extraction_preprocessing(path_csv, filenames, dataset_name, skip_rows)
    #dataframes.plotting_dataframe(dataframes.dataframes, "Initial plots")
    
    # Applying filter
    dataframes.filter_median(lenght_moving_average)
    #dataframes.plotting_dataframe(dataframes.dataframes, "Post-filtering plots")
    
    # Normalization
    dataframes.normalization()
    #dataframes.plotting_dataframe(dataframes.dataframes_norm, "Normalized timeseries plots")
    
    # Scaling
    dataframes.scaling()
    #dataframes.plotting_dataframe(dataframes.dataframes_scaled, "Scaled timeseries plots")
    
    # Reformed dataset
    if dataset_name == 'Multivariate_v1':
        dataframes_reformed = [dataframes.dataframes_norm[0], dataframes.dataframes_norm[1], 
                               dataframes.dataframes_scaled[2], dataframes.dataframes_norm[3]]
        
    
    ### SIMILARITY IN TIME CLUSTER ANALYSIS ###
    ## Distance matrix
    count_nonzero = np.count_nonzero(alphas)
    
    # Euclidean
    model_euc = Clustering_hierarchical(dataframes_scaled = dataframes.dataframes_scaled)
    model_euc.distance_matrix_euc(alphas)
    
    ## Internal indexes
    methods = ['single', 'complete', 'average', 'ward']
    metric = 'euclidean' # internal distance, NOT the similarity measure
    
    print("Euclidean internal indexes")
    similarity_measure = 'euclidean'
    cophenet_yaxis = 0.63  # Adjust this for the location of the Cophenet index in the plot of the dendrogram
    internal_indexes = Internal_indexes(model_euc.dist_cond, model_euc.dist_cond_original,
                                        count_nonzero, dataframes.dataframes_scaled)
    internal_indexes.calculation_internal_indexes(methods, metric, similarity_measure)
    internal_indexes.plotting_internal_indexes(similarity_measure, dataset_name, cophenet_yaxis, file_ending,
                                               save_figure = False)
    
    # Plotting the dendrogram with the given method
    method = 'single'
    metric = 'euclidean'
    cut_distance = 250000  # Only used for visualising the cut in the dendrogram
    model_euc.plot_dendrogram(method, metric, cut_distance, dataframes.dataframes, path_pictures_euc,
                              file_ending)
    
    num_cuts = 3 # Cuts the dendrogram into 'num_cuts' partitions
    print(count_nonzero)
    df_names = ['power', 'gearboxTemp','genSpd', 'windSpd', 'windDir', 'extTemp']
    model_euc.print_clusters(dataframes.dataframes_norm[:count_nonzero], method, metric, num_cuts,
                             count_nonzero, path_pictures_euc, save_plot=False)
    
    
    
    ### SIMILARITY IN SHAPE CLUSTER ANALYSIS ###
    ## DTW distance
    if dataset_name == 'Multivariate_v1':
        model_dtw = Clustering_hierarchical(dataframes_norm = dataframes_reformed)
    else:
        model_dtw = Clustering_hierarchical(dataframes_norm = dataframes.dataframes_norm)
    
    model_dtw.distance_matrix_dtw(alphas, window_size_dtw)
    
    ## Internal indexes
    methods = ['single', 'complete', 'average', 'ward']
    metric = 'euclidean' # internal distance, NOT the similarity measure

    print("DTW internal indexes")
    similarity_measure = 'dtw'
    cophenet_yaxis = 0.72  # Adjust this for the location of the Cophenet index in the plot of the dendrogram
    internal_indexes = Internal_indexes(model_dtw.dist_cond, model_dtw.dist_cond_original, 
                                        count_nonzero, dataframes.dataframes_scaled)
    internal_indexes.calculation_internal_indexes(methods, metric, similarity_measure)
    internal_indexes.plotting_internal_indexes(similarity_measure, dataset_name, cophenet_yaxis, file_ending,
                                               save_figure=True)
    
    # Plotting the dendrogram with the given method
    method = 'single'
    metric = 'euclidean'
    cut_distance = 250000  # Only used for visualising the cut in the dendrogram
    model_dtw.plot_dendrogram(method, metric, cut_distance, dataframes.dataframes, path_pictures_dtw,
                              file_ending)
    
    # Plotting the timeseries and the cluster assignment
    num_cuts = 3 # Cuts the dendrogram into 'num_cuts' partitions
    print(count_nonzero)
    df_names = ['power', 'gearboxTemp','genSpd', 'windSpd', 'windDir', 'extTemp']
    model_dtw.print_clusters(dataframes.dataframes_norm[:count_nonzero], method, metric, num_cuts,
                             count_nonzero, path_pictures_dtw, save_plot=True)

